# Summary

[版本修订记录](./changelog.md)

- [前言](./preface.md)
- [项目组织结构]()
  - [各种文件的功能]()
  - [代码文件的组织]()
- [C++语言要点]()
- [源码文件结构]()
- [预处理指令]()
- [命名空间]()
- [内置数据类型]()
  - [基本数据类型]()
  - [数组]()
  - [字符串]()
  - [类型转换]()
- [复杂数据类型]()
  - [结构]()
  - [联合]()
  - [枚举]()
  - [类型别名]()
- [操作符]()
- [控制结构]()
  - [分支语句]()
  - [循环语句]()
- [函数定义]()
  - [形参与实参]()
  - [参数默认值]()
  - [Lambda 表达式]()
  - [内联函数]()
- [指针操作]()
  - [指针变量的声明]()
  - [指针的使用]()
  - [指针的运算]()
  - [指针与数组]()
  - [指针的指针]()
  - [利用指针构建复杂数据结构]()
  - [指针做为函数参数和返回值]()
  - [函数指针]()
- [引用]()
  - [引用做为函数参数和返回值]()
- [内存空间的分配与释放]()
- [关于类]()
  - [类的声明格式]()
  - [成员函数定义]()
  - [构造函数与析构函数]()
  - [继承]()
  - [重载操作符]()
  - [创建实例]()
  - [友元]()
- [异常处理]()
  - [调用`about`]()
  - [使用异常]()
- [`const`的使用]()
- [泛型]()
  - [函数模板]()
  - [类模板]()
  - [非类型模板形参]()
- [文件操作]()
  - [标准输入输出]()
  - [文件处理]()
- [常用数据结构]()
  - [容器类]()
  - [`std::size_t`]()
  - [智能指针]()
- [常用库]()
  - [如何将库加入项目依赖]()
  - [标准库]()
- [makefile 编制]()
  - [条目规则]()
  - [变量]()
- [CMake 配置]()
  - [基本配置]()
  - [添加多个源码文件]()
  - [设定输出目录]()
  - [将子目录内容编译为链接库]()
  - [自定义变量]()
  - [添加第三方库]()
- [项目编译]()
- [C++11 新特性]()
- [C++14 新特性]()
